/*:
CC -O -c AppendRow.c  -o AppendRow.o
ar -r TabText.a AppendRow.o
del AppendRow.o
*/
#include "defTable.h"

unsigned char AppendRow(Table *f, Table *fi, size_t i, size_t anz)
{ char **a=f->Table+f->lTable, **aa=fi->Table+i;
  size_t lLine=*(f->Col+f->asp), ll=anz;
  
  if( (lLine!=*(fi->Col+fi->asp)) || (f->asp!=fi->asp)
      || memcmp(f->Col, fi->Col, sizeof(size_t)*f->asp) 
      || (f==fi) || (i+anz>fi->lTable) ) return 0;
  if( anz>f->lFree ) a=NewTable(f, anz+EXTRA);
  f->lFree-=anz;
  while( ll-- )
    *a=Alloc(lLine), memcpy(*a, *aa, lLine), a++, aa++;
  f->lTable+=anz; return 1;
}

unsigned char AppendRow(Table *f, char *s)
{ char **a=f->Table+f->lTable, *ss, *z, *zz;
  size_t l=strlen(s), asp=f->asp, 
      lLine=*(f->Col+asp), lz=1, *col=f->Col, ls;

  if( !l || !lLine ) return 0;
  if( *(s+l-1)=='\n' ) *(s+l-1)=0, l--;
  if( !l ) return 0;

  if( !f->lFree ) a=NewTable(f, EXTRA);
  ss=*a=Alloc(lLine), z=s;
  while( asp>1 )
  { z+=strspn(z, " "), zz=z+strcspn(z, " "), lz=zz-z;
    if( !lz ) break;
    ls=*(col+1)-*col-1;
    if( lz<ls ) memcpy(ss, z, lz);
    else memcpy(ss, z+lz-ls, ls);
    z=zz, ss+=ls+1, col++, asp--;
  }
  if( lz )
  { z+=strspn(z, " "), lz=strlen(z), ls=*(col+1)-*col-1;
    if( lz<ls ) memcpy(ss, z, lz);
    else memcpy(ss, z+lz-ls, ls);
  }
  f->lTable++; return 1;
}
