/*:
CC -O -c ChangeColumnWidth.c -o ChangeColumnWidth.o
ar -r TabText.a ChangeColumnWidth.o
del ChangeColumnWidth.o
*/
#include "defTable.h"

unsigned char ChangeColumnWidth(Table *f, size_t j, size_t nwidth)
{ char **a=f->Table, *aa;
  j--;
  size_t asp=f->asp, ll=*(f->Col+j+1)-*(f->Col+j),
       le=*(f->Col+asp)-ll, lTable=f->lTable, anz, 
       lz=le+nwidth+1, *col=f->Col+j;
  
  if( !(j<asp) || !lTable || !nwidth 
     || (nwidth+1==ll) ) return 0;
  nwidth++, anz=lTable;
  while( anz-- )
  { if( !(strlen( *a+*col )<nwidth) ) return 0;
    aa=Alloc(lz), memcpy(aa, *a, *(col+1)),
    memcpy(aa+*col+nwidth, *a+*(col+1), le), 
    Free(*a), *a=aa, a++;
  }
  while( asp-- )
    col++, *col=(*col-ll)+nwidth;
  return 1;
}

unsigned char ChangeColumnWidth(Table *f, char *s , size_t nwidth)
{ return ChangeColumnWidth(f, SearchColumn(f, s), nwidth);}
