/*:
CC -O -c DeleteLine.c -o DeleteLine.o
ar -r TabText.a DeleteLine.o
del DeleteLine.o
*/
#include "defText.h"

unsigned char DeleteLine(Text *f, size_t anz)
{ char *a=f->Line;
  size_t l=0, ll=f->lText-(f->Line-f->Text);
         
  if( !a || !anz ) return 0;
  while( *a && anz-- ) a=strchr(a, '\n')+1;
  l=a-f->Line, memmove(f->Line, a, ll-l+1), 
  f->lText-=l, f->lFree+=l; 
  return 1;
}

unsigned char DeleteLine(Text *f, char *s)
{ char *a=f->Line, *b, *ss, *aa, *z, *ze, cc;
  size_t l, lz, lA;
         
  if( !f->lText || !a || !*a ) return 0;
  lA=f->lFree;
  if( !s )
  { b=strchr(a, '\n'), 
    memmove(a, b+1, f->lText-(b-f->Text)),
    f->lFree=lA+b-a+1, f->lText-=(b-a+1);
    return 1;
  }
  if( !*s )
  { *a=0, f->lFree-=(a-f->Text),
    f->lText=a-f->Text, f->Word=f->Line=a;
    return 1;
  }
  l=strlen(s), z=f->Output, strcpy(z, s), 
  *(z+l+1)=0, ze=z+l+1;
  while( *z ) 
    if( ss=strchr(z,'*') ) 
      *ss=0, z=ss+1; else break;
  while( *a )
  { z=f->Output;
    if( !*z )
    { if( !*(z+1) )
      { aa=strchr(a, '\n' ),
        memmove(a, aa+1, f->lText-(aa-f->Text)),
        f->lFree=lA+(aa-a+1), f->lText-=(aa-a+1), 
        a=aa+1; continue;
      }
      b=a, z++;
    }
    else
    { if( !(aa=Strstr(a,z)) ) return 0;
      b=aa; 
      while( (b>a) && (*b!='\n') ) b--;
      b++, cc=*aa, *aa=0;
      if( (b+strspn(b, f->Ignore) )!=aa )
      { *aa=cc, a=strchr(aa, '\n')+1; continue;}
      *aa=cc, lz=strlen(z), z+=lz, a=f->Line=f->Word=b, 
      b=aa+lz;
    }
    ss=strchr(b, '\n'), *ss=0;
    while( *b )
    { if( !*z )
      { z++; if( !*z ){ z++; break;}}
      else
      { if( !(aa=Strstr(b, z)) )
        { *ss='\n', a=ss+1, ss=0; break;}
        lz=strlen(z), z+=lz, b=aa+lz;
      }
    }
    if( !ss )continue;
    if( !(z<ze) ) 
      memmove(a, ss+1, f->lText-(int)(ss-f->Text)),
      f->lFree=lA+(ss-a+1), f->lText-=(ss-a+1), 
      a=ss+1;
    *ss='\n';
  }
  return 1;
}
