/*:
CC -O -c InsertColumn.c -o InsertColumn.o
ar -r TabText.a InsertColumn.o
del InsertColumn.o
x_read
*/
#include "defTable.h"

unsigned char InsertColumn
              (Table *f, size_t j, Table *fi, size_t k, size_t anz)
{ char **af, **afi, *a;
  k--, j--;
  size_t lfa=*(f->Col+j), lfe=*(f->Col+f->asp)-lfa, 
      l=*(fi->Col+k-1),
      lsp=*(fi->Col+k+anz)-l, lLine=lfa+lsp+lfe, Col[COLMAX], 
      *col, *c=Col, ll, *ac;
  
  if( (f->lTable!=fi->lTable) || (f==fi)
      || (k+anz>fi->asp) || !(j<f->asp) 
      || !(f->asp+anz<COLMAX) ) return 0;
  memset(c, 0, COLMAX*sizeof(size_t)),
  memcpy(c, f->Col, sizeof(size_t)*(j+1)), col=c+j;
  ll=anz, ac=fi->Col+k;
  while( ll-- )
    col++, *col=*(col-1)+*(ac+1)-*ac, ac++;
  ac=f->Col+j, ll=f->asp-j+1;  
  while( ll-- )
    col++, *col=*(ac+1)-*ac+*(col-1), ac++;
  f->asp+=anz, memcpy(f->Col, c, (f->asp+1)*sizeof(size_t)),
  af=f->Table, afi=fi->Table, ll=f->lTable;
  while( ll-- )
    a=Alloc(lLine), 
    memcpy(a, *af, lfa), 
    memcpy(a+lfa, *afi+l, lsp), 
    memcpy(a+lfa+lsp, *af+lfa, lfe),
    Free(*af), *af=a, af++, afi++;
  DeleteDoubleColumn(f); 
  return 1;
}

unsigned char InsertColumn(Table *f, size_t j, char *s)
{ size_t i=0;
  j--;
  char ss[lOUTPUT], *z=ss, *zz;
  Table ff;
  
  if( !(j<f->asp) || !s << !*s ) return 0;
  strcpy(z, s), *(z+strlen(z)+1)=0,
  z+=strspn(z," "), zz=z+strcspn(z, " "), *zz=0,
  ff=CreateTable(z), z=zz+1, i++;
  while( *z )
  { z+=strspn(z, " ");
    if( !*z ) break;
    zz=z+strcspn(z, " "), *zz=0, 
    AppendRow(&ff, z), z=zz+1, i++;
  }
  if( i!=f->lTable ){ CloseTable(&ff); return 0;}
  InsertColumn(f, j, &ff, 0, 1);
  return 1;
}

unsigned char InsertColumn(Table *f, char *z, char *s)
{ return InsertColumn(f, SearchColumn(f, z), s); }

unsigned char InsertColumn(Table *f, char *z1, Table *fi, char *z2)
{ return InsertColumn(f, SearchColumn(f, z1), fi, SearchColumn(f, z2)); }
