/*:
CC -O -c JoinTable.c -o JoinTable.o
ar -r TabText.a JoinTable.o
del JoinTable.o
*/
#include "defTable.h"

Table JoinTable(Table *f, size_t j, Table *fi, size_t k, size_t anz)
{ char **af=f->Table, **afi=fi->Table, **aff, *a;
  j--, k--;
  size_t *colf=f->Col, *colfi=fi->Col, *cf=colf+j, *cfi=colfi+k,
         ll=*(cf+anz)-*cf, *col, asp, lff, aspf=f->asp, aspfi=fi->asp,
         lf=f->lTable, lLinef=*(f->Col+aspf), lLinefi=*(fi->Col+aspfi),
         lfi;
  Table ff=OpenTable();
  
  if( (ll!=*(cfi+anz)-*cfi) || memcmp(*af+*cf, *afi+*cfi, ll ) ) return ff;
  if( anz==aspfi )
  { lff=lLinef,  col=ff.Col,
    memcpy(col, colf, sizeof(size_t)*(aspf+1)),
    asp=ff.asp=aspf,
    aff=ff.Table, *aff=Alloc(lff),
    memcpy(*aff, *af, lLinef),
    aff++, ff.lTable++, ff.lFree--;
    while( --lf )
    { af++, lfi=fi->lTable, a=*af+*cf, afi=fi->Table+1;
      while( --lfi )
      { if( !memcmp(a, *afi+*cfi, ll) )
        { if( !ff.lFree ) aff=NewTable(&ff, EXTRA);
          *aff=Alloc(lff),
          memcpy(*aff, *af, lLinef),
          aff++, ff.lTable++, ff.lFree--;
        }
        afi++;
      }
    }
  }
  else
  { lff=lLinef+lLinefi, col=ff.Col,
    memcpy(col, colf, sizeof(size_t)*(aspf+1)),
    asp=ff.asp=aspf+aspfi, col+=aspf+1,
    memcpy(col, colfi+1, sizeof(size_t)*aspfi),
    lfi=*(f->Col+aspf), col=ff.Col+aspf;
    while( aspfi-- ) col++, *col+=lfi;
    aff=ff.Table, *aff=Alloc(lff),
    memcpy(*aff, *af, lLinef),
    memcpy(*aff+lLinef, *afi, lLinefi),
    aff++, ff.lTable++, ff.lFree--;
    while( --lf )
    { af++, lfi=fi->lTable, a=*af+*cf, afi=fi->Table+1;
      while( --lfi )
      { if( !memcmp(a, *afi+*cfi, ll) )
        { if( !ff.lFree ) aff=NewTable(&ff, EXTRA);
          *aff=Alloc(lff),
          memcpy(*aff, *af, lLinef),
          memcpy(*aff+lLinef, *afi, lLinefi),
          aff++, ff.lTable++, ff.lFree--;
        }
        afi++;
      }
    }
    DeleteDoubleColumn(&ff);
  }
  return ff; 
}

Table JoinTable(Table *f, char *z1, Table *fi, char *z2)
{ return JoinTable(f, SearchColumn(f, z1), fi, SearchColumn(f, z2)); }
