/*:
CC -O -c PrintText.c -o PrintText.o
ar -r TabText.a PrintText.o
del PrintText.o
*/
#include "defText.h"

unsigned char PrintText(Text *f, char* name, char *mode)
{ if( !name || !f->lText) return 0;
  if( *name )
  { FILE *fo;
    if( !(fo=fopen(name,mode)) )
    { fprintf(stderr, "*** Open error %s\n", name); 
      return 0;
    }
    fprintf(fo, "%s", f->Text), fclose(fo);
  }
  else printf("%s", f->Text);
  return 1;
}
