/*:
CC -O -c SortTableInvers.c -o SortTableInvers.o
ar -r TabText.a SortTableInvers.o
del SortTableInvers.o
*/
#include "defTable.h"

void SortInvers_(size_t lo, size_t hi, char **c)
{ char x[lOUTPUT], out[lOUTPUT];
  static char **a;
  static size_t lLine, v;
  size_t i=lo, j=hi;
         
  if( c ){ lLine=lo, a=c, v=hi; return;}
  strcpy(x, *(a+(i+j)/2)+v);
  while( i<=j )
  { while( Strcmp(*(a+i)+v, x)>0 ) i++;
    while( Strcmp(*(a+j)+v, x)<0 ) j--;
    if( i<=j )
    { if( i<j )
      memcpy(out, *(a+i), lLine), 
      memcpy(*(a+i), *(a+j), lLine),
      memcpy(*(a+j), out, lLine);
      i++, j--;
    }
  }
  if( lo<j ) SortInvers_(lo, j, 0);
  if( i<hi ) SortInvers_(i, hi, 0);
}

unsigned char SortTableInvers(Table *f, size_t j)
{ j--;
  if( !f->lTable || !(j<f->asp) ) return 0;
  SortInvers_(*(f->Col+f->asp), *(f->Col+j), f->Table),
  SortInvers_(1, f->lTable-1, 0);
  return 1;
}

unsigned char SortTableInvers(Table *f, char *s)
{ return SortTableInvers(f, SearchColumn(f, s)); }
