/*:
CC -O -c SwapColumn.c -o SwapColumn.o
ar -r TabText.a SwapColumn.o
del SwapColumn.o
*/
#include "defTable.h"

unsigned char SwapColumn(Table *f, size_t j, size_t k)
{ Table f1, f2;
  size_t l;
  j--, k--;
  if( j==k ) return 1;
  if( j>k ) l=j, j=k, k=l;
  f1=GetColumn(f, j, 1),
  f2=GetColumn(f, k, 1),
  DeleteColumn(f, j, 1),
  InsertColumn(f, j, &f2, 0, 1),
  DeleteColumn(f, k, 1),
  InsertColumn(f, k, &f1, 0, 1),
  CloseTable(&f1),
  CloseTable(&f2);
  return 1;
}

unsigned char SwapColumn(Table *f, char *s1, char *s2)
{ return SwapColumn(f, SearchColumn(f, s1), SearchColumn(f, s2)); }
