/*:
CC -O -c AppendColumn.c -o AppendColumn.o
ar -r TabText.a AppendColumn.o
del AppendColumn.o
*/
#include "defTable.h"

unsigned char AppendColumn(Table *f, 
                           Table *fi, size_t j, size_t anz)
{ char **af, **afi, *a;
  j--;
  size_t l=*(fi->Col+j), lf=*(f->Col+f->asp), 
      lfi=*(fi->Col+f->asp)-l, 
      lLine=lf+lfi, ll, *col, *ac;
  
  if( (f->lTable!=fi->lTable) || (f==fi) || (j+anz>fi->asp) 
       || !(f->asp+anz<COLMAX) ) return 0;
  memcpy(f->Col+f->asp+1, fi->Col+j+1,
         (size_t)(anz*sizeof(size_t))),
  col=f->Col+f->asp, ac=fi->Col+j, ll=anz;
  while( ll-- ) ac++, col++, *col=*ac-*(ac-1);
  ll=anz, col=f->Col+f->asp;
  while( ll-- ) col++, *col+=*(col-1);
  af=f->Table, afi=fi->Table, ll=fi->lTable;
  while( ll-- )
    a=Alloc(lLine), memcpy(a, *af, (size_t)lf), 
    memcpy(a+lf, *afi+l,(size_t)lfi), 
    Free(*af), *af=a, af++, afi++;
  f->asp+=anz; 
  DeleteDoubleColumn(f); 
  return 1;
}
