/*:
CC -O -c AppendLine.c -o AppendLine.o
ar -r TabText.a AppendLine.o
del AppendLine.o
*/
#include "defText.h"

unsigned char AppendLine(Text *f, char *s)
{ char *a=f->Text;
  size_t l, lA=f->lFree, lT=f->lText;
         
  if( !s ) return 0;
  l=strlen(s);
  if( lA<l+1 )
  { a=Alloc(lT+l+EXTRA), strcpy(a, f->Text), lA=EXTRA+l;
    if( f->Text ) Free(f->Text); 
    f->Text=a;
  }
  a+=lT, strcpy(a ,s), lT+=l, a+=l;
  if( *(a-1)!='\n' ) 
    *a='\n', lT++, *(++a)=0, lA--;
  f->lText=lT, f->lFree=lA-l, f->Line=f->Word=a;
  return 1;
}
