/*:
CC -O -c DeleteRow.c -o DeleteRow.o
ar -r TabText.a DeleteRow.o
del DeleteRow.o
*/
#include "defTable.h"

unsigned char DeleteRow(Table *f, size_t i, size_t anz)
{ char **a=f->Table, **aa;
  size_t lTable=f->lTable, ianz=anz;
         
  if( !lTable || (i+anz>lTable) ) return 0;
  aa=a+i;
  while( ianz--)
    Free(*aa), aa++;
  if( anz<lTable ) 
    memmove(a+i, a+i+anz, 
            (size_t)(sizeof(char*)*(lTable-anz)));
  memset(a+lTable-anz, 0, sizeof(char*)*anz), 
  f->lTable-=anz, f->lFree+=anz;
  return 1;
}
