/*:
CC -O -c GetRow.c -o GetRow.o
ar -r TabText.a GetRow.o
del GetRow.o
*/
#include "defTable.h"

Table GetRow(Table *f, size_t i, size_t anz)
{ char **a, **aa;
  size_t lTable=f->lTable, lLine=*(f->Col+f->asp), 
      lA=EXTRA+(anz+1), l=anz;
  Table ff=OpenTable();
  
  memcpy(ff.Col, f->Col, sizeof(size_t)*COLMAX),
  ff.asp=f->asp, Free(ff.Table),
  aa=ff.Table=(char**)Alloc(sizeof(char*)*lA),
  ff.lFree=lA-1;
  if( !lTable || (i+anz>lTable) ) return ff;
  *aa=Alloc(lLine), memcpy(*aa, *f->Table, lLine);
  if( i )
  { aa++, a=f->Table+i; 
    while( l-- )
      *aa=Alloc(lLine), memcpy(*aa, *a, lLine),
      aa++, a++;
    anz++;
  }
  ff.lTable=anz, ff.lFree-=anz;
  return ff;
}

Table GetRow(Table *f, size_t j, char *s)
{ char *b, *ss, *z, *ze, *cc, **a, **af, **afe=f->Table+f->lTable;
  j--;
  size_t l, lz, *col=f->Col+j, lLine=*(f->Col+f->asp);
  Table ff=OpenTable();
    
  if( !(f->lTable) || !(j<f->asp) || !s ) return ff;
  if( !(l=strlen(s)) ) return ff;
  memcpy(ff.Col, f->Col, sizeof(size_t)*(f->asp+1)),
  *ff.Table=Alloc(lLine), ff.lTable=1, ff.lFree--,
  memcpy(*ff.Table, *f->Table, lLine), ff.asp=f->asp,
  z=ff.Output, strcpy(z,s), ze=z+l, *(ze+1)=0;
  while( *z )
    if( z=strchr(z, '*') ) *z=0, z++; else break;
  a=ff.Table+1, af=f->Table;
  while( ++af<afe )
  { z=ff.Output, ss=*af+*col, cc=ss;
    if( !*z ) b=cc, z++;
    else
    { lz=strlen(z);
      if( Strncmp(cc, z, lz) ) continue;
      z+=lz, b=cc+lz;
    }
    while( *b )
    { if( !*z )
      { if( z<ze ){ z++; continue;}
        if( !*(z-1) ) b=ss+strlen(ss); break;
      }
      else
      { if( !(cc=Strstr(b, z)) ) break;
        lz=strlen(z), z+=lz, b=cc+lz;
      }
    }
    if( !*b && !*(z+1) ) 
    {  if( !ff.lFree ) a=NewTable(&ff, EXTRA);
       *a=Alloc(lLine), memcpy(*a, *af, lLine), a++,
       ff.lTable++, ff.lFree--;
    }
  }
  return ff;
}

Table GetRow(Table *f, char *z, char *s)
{ return GetRow(f, SearchColumn(f, z), s);}
  
