/*:
CC -O -c InsertFile.c -o InsertFile.o
ar -r TabText.a InsertFile.o
del InsertFile.o
*/
#include "defText.h"
#include <stdlib.h>

extern unsigned char InsertLine(Text*, char*);

unsigned char InsertFile(Text *f, char *name)
{ char *a=f->Output;
  FILE *file;
  
  if( !name ) return 0;
  if( *name )
  { if( !(file=fopen(name, "r")) )
    { fprintf(stderr, "*** Open error: %s\n", name); 
      return 0;
    }
    while( fgets(a, lOUTPUT, file) )
      if( !InsertLine(f, a) ) return 0;
    fclose(file);
  }
  else 
    while( gets(a) ) 
      if( !InsertLine(f, a) ) return 0;
  return 1;
}
