/*:
CC -O -c PrintTable.c -o PrintTable.o 
ar -r TabText.a PrintTable.o
del PrintTable.o
*/
#include "defTable.h"

unsigned char PrintTable(Table *f, char* name, char *mode)
{ FILE *fo;
  char **a=f->Table, c[7*(COLMAX+1)], *cc;
  size_t *col=f->Col, asp=f->asp, ll=f->lTable;
         
  memset(c, 0, 7*(COLMAX+1));
  if( !*name ) fo=stdout;
  else
    if( !(fo=fopen(name,mode)) )
    { fprintf(stderr, "*** Open error %s\n", name); return 0;}
  if( !ll ) return 0;
  cc=c, sprintf(cc, "%%%is", *(col+1)-1), col++, cc+=7;
  while( --asp )
    sprintf(cc, " %%%is", *(col+1)-*col-1), col++, cc+=7;
  while( ll-- )
  { cc=c, col=f->Col, asp=f->asp;
    while( asp-- ) fprintf(fo, cc, *a+*col), cc+=7, col++;
    fprintf(fo, "\n"), a++;
  }
  if( *name ) fclose(fo);
  return 1;
}
