/*:
CC -O -c SortTableNum.c -o SortTableNum.o
ar -r TabText.a SortTableNum.o
del SortTableNum.o
*/
#include "defTable.h"
#include <stdlib.h>

void Sortnum_(size_t lo, size_t hi, char **c)
{ char out[lOUTPUT];
  static char **a;
  static size_t lLine, v;
  size_t i=lo, j=hi, ix;
         
  if( c ){ lLine=lo, a=c, v=hi; return;}
  ix=atol(*(a+(i+j)/2)+v);
  while( i<=j )
  { while( atol(*(a+i)+v)<ix ) i++;
    while( atol(*(a+j)+v)>ix ) j--;
    if( i<=j )
    { if( i<j )
      memcpy(out, *(a+i), lLine), 
      memcpy(*(a+i), *(a+j), lLine),
      memcpy(*(a+j), out, lLine);
      i++, j--;
    }
  }
  if( lo<j ) Sortnum_(lo, j, 0);
  if( i<hi ) Sortnum_(i, hi, 0);
}

unsigned char SortTableNum(Table *f, size_t j)
{ j--;
  if( !f->lTable || !(j<f->asp) ) return 0;
  Sortnum_(*(f->Col+f->asp), *(f->Col+j), f->Table),
  Sortnum_(1, f->lTable-1, 0);
  return 1;
}

unsigned char SortTableNum(Table *f, char *s)
{ return SortTableNum(f, SearchColumn(f, s)); }
