/*:
CC -O -c SortTableNumInvers.c -o SortTableNumInvers.o
ar -r TabText.a SortTableNumInvers.o
del SortTableNumInvers.o
*/
#include "defTable.h"
#include <stdlib.h>

void SortnumInvers_(size_t lo, size_t hi, char **c)
{ char out[lOUTPUT];
  static char **a;
  static size_t lLine, v;
  size_t i=lo, j=hi, ix;
         
  if( c ){ lLine=lo, a=c, v=hi; return;}
  ix=atol(*(a+(i+j)/2)+v);
  while( i<=j )
  { while( atol(*(a+i)+v)>ix ) i++;
    while( atol(*(a+j)+v)<ix ) j--;
    if( i<=j )
    { if( i<j )
      memcpy(out, *(a+i), lLine), 
      memcpy(*(a+i), *(a+j), lLine),
      memcpy(*(a+j), out, lLine);
      i++, j--;
    }
  }
  if( lo<j ) SortnumInvers_(lo, j, 0);
  if( i<hi ) SortnumInvers_(i, hi, 0);
}

unsigned char SortTableNumInvers(Table *f, size_t j)
{ j--;
  if( !f->lTable || !(j<f->asp) ) return 0;
  SortnumInvers_(*(f->Col+f->asp), *(f->Col+j), f->Table),
  SortnumInvers_(1, f->lTable-1, 0);
  return 1;
}

unsigned char SortTableNumInvers(Table *f, char *s)
{ return SortTableNumInvers(f, SearchColumn(f, s)); }
