#!/bin/bash
  rm TabText.a
  
  echo "*** Table functions ***"
  
  CC -O -c OpenTable.c -o OpenTable.o
  ar -r TabText.a OpenTable.o
  rm OpenTable.o
  echo OpenTable
  
  CC -O -c NewTable.c -o NewTable.o
  ar -r TabText.a NewTable.o
  rm NewTable.o
  echo NewTable

  CC -O -c CloseTable.c -o CloseTable.o
  ar -r TabText.a CloseTable.o
  rm CloseTable.o
  echo CloseTable

  CC -O -c CreateTable.c -o CreateTable.o
  ar -r TabText.a CreateTable.o
  rm CreateTable.o
  echo CreateTable

  CC -O -c CopyTable.c -o CopyTable.o
  ar -r TabText.a CopyTable.o
  rm CopyTable.o
  echo CopyTable

  CC -O -c PrintTable.c -o PrintTable.o
  ar -r TabText.a PrintTable.o
  rm PrintTable.o
  echo PrintTable

  CC -O -c GetEntry.c -o GetEntry.o
  ar -r TabText.a GetEntry.o
  rm GetEntry.o
  echo GetEntry

  CC -O -c GetRow.c -o GetRow.o
  ar -r TabText.a GetRow.o
  rm GetRow.o
  echo GetRow

  CC -O -c JoinTable.c -o JoinTable.o
  ar -r TabText.a JoinTable.o
  rm JoinTable.o
  echo JoinTable

  CC -O -c GetColumn.c -o GetColumn.o
  ar -r TabText.a GetColumn.o
  rm GetColumn.o
  echo GetColumn

  CC -O -c SearchColumn.c -o SearchColumn.o
  ar -r TabText.a SearchColumn.o
  rm SearchColumn.o
  echo SearchColumn

  CC -O -c PutEntry.c -o PutEntry.o
  ar -r TabText.a PutEntry.o
  rm PutEntry.o
  echo PutEntry

  CC -O -c PutRow.c -o PutRow.o
  ar -r TabText.a PutRow.o
  rm PutRow.o
  echo PutRow

  CC -O -c PutColumn.c -o PutColumn.o
  ar -r TabText.a PutColumn.o
  rm PutColumn.o
  echo PutColumn

  CC -O -c AppendRow.c -o AppendRow.o
  ar -r TabText.a AppendRow.o
  rm AppendRow.o
  echo AppendRow

  CC -O -c AppendColumn.c -o AppendColumn.o
  ar -r TabText.a AppendColumn.o
  rm AppendColumn.o
  echo AppendColumn

  CC -O -c InsertRow.c -o InsertRow.o
  ar -r TabText.a InsertRow.o
  rm InsertRow.o
  echo InsertRow

  CC -O -c InsertColumn.c -o InsertColumn.o
  ar -r TabText.a InsertColumn.o
  rm InsertColumn.o
  echo InsertColumn

  CC -O -c DeleteRow.c -o DeleteRow.o
  ar -r TabText.a DeleteRow.o
  rm DeleteRow.o
  echo DeleteRow

  CC -O -c DeleteDoubleRow.c -o DeleteDoubleRow.o
  ar -r TabText.a DeleteDoubleRow.o
  rm DeleteDoubleRow.o
  echo DeleteDoubleRow

  CC -O -c DeleteColumn.c -o DeleteColumn.o
  ar -r TabText.a DeleteColumn.o
  rm DeleteColumn.o
  echo DeleteColumn

  CC -O -c DeleteDoubleColumn.c -o DeleteDoubleColumn.o
  ar -r TabText.a DeleteDoubleColumn.o
  rm DeleteDoubleColumn.o
  echo DeleteDoubleColumn

  CC -O -c SwapRow.c -o SwapRow.o
  ar -r TabText.a SwapRow.o
  rm SwapRow.o
  echo SwapRow
  
  CC -O -c SwapColumn.c -o SwapColumn.o
  ar -r TabText.a SwapColumn.o
  rm SwapColumn.o
  echo SwapColumn

  CC -O -c ColumnToLine.c -o ColumnToLine.o 
  ar -r TabText.a ColumnToLine.o
  rm ColumnToLine.o
  echo ColumnToLine

  CC -O -c RowToLine.c -o RowToLine.o
  ar -r TabText.a RowToLine.o
  rm RowToLine.o
  echo RowToLine

  CC -O -c GetColumnWidth.c -o GetColumnWidth.o
  ar -r TabText.a GetColumnWidth.o
  rm GetColumnWidth.o
  echo GetColumnWidth

  CC -O -c SetColumnWidth.c -o SetColumnWidth.o
  ar -r TabText.a SetColumnWidth.o
  rm SetColumnWidth.o
  echo SetColumnWidth

  CC -O -c ChangeColumnWidth.c -o ChangeColumnWidth.o
  ar -r TabText.a ChangeColumnWidth.o
  rm ChangeColumnWidth.o
  echo ChangeColumnWidth

  CC -O -c SortTable.c -o SortTable.o
  ar -r TabText.a SortTable.o
  rm SortTable.o
  echo SortTable

  CC -O -c SortTableInvers.c -o SortTableInvers.o
  ar -r TabText.a SortTableInvers.o
  rm SortTableInvers.o
  echo SortTableInvers

  CC -O -c SortTableNum.c -o SortTableNum.o
  ar -r TabText.a SortTableNum.o
  rm SortTableNum.o
  echo SortTableNum

  CC -O -c SortTableNumInvers.c -o SortTableNumInvers.o
  ar -r TabText.a SortTableNumInvers.o
  rm SortTableNumInvers.o
  echo SortTableNumInvers

  echo "*** Text functions ***"
  
  CC -O -c OpenText.c -o OpenText.o
  ar -r TabText.a OpenText.o
  rm OpenText.o
  echo OpenText

  CC -O -c CloseText.c -o CloseText.o
  ar -r TabText.a CloseText.o
  rm CloseText.o
  echo CloseText

  CC -O -c CopyText.c -o CopyText.o
  ar -r TabText.a CopyText.o
  rm CopyText.o
  echo CopyText

  CC -O -c ResetText.c -o ResetText.o
  ar -r TabText.a ResetText.o
  rm ResetText.o
  echo ResetText

  CC -O -c PrintText.c -o PrintText.o
  ar -r TabText.a PrintText.o
  rm PrintText.o
  echo PrintText

  CC -O -c GetLine.c -o GetLine.o
  ar -r TabText.a GetLine.o
  rm GetLine.o
  echo GetLine

  CC -O -c GetWord.c -o GetWord.o
  ar -r TabText.a GetWord.o
  rm GetWord.o
  echo GetWord

  CC -O -c GetWordinLine.c -o GetWordinLine.o
  ar -r TabText.a GetWordinLine.o
  rm GetWordinLine.o
  echo GetWordinLine

  CC -O -c NextLine.c -o NextLine.o
  ar -r TabText.a NextLine.o
  rm NextLine.o
  echo NextLine

  CC -O -c PreviousLine.c -o PreviousLine.o
  ar -r TabText.a PreviousLine.o
  rm PreviousLine.o
  echo PreviousLine

  CC -O -c InsertLine.c -o InsertLine.o
  ar -r TabText.a InsertLine.o
  rm InsertLine.o
  echo InsertLine

  CC -O -c InsertText.c -o InsertText.o
  ar -r TabText.a InsertText.o
  rm InsertText.o
  echo InsertText

  CC -O -c InsertFile.c -o InsertFile.o
  ar -r TabText.a InsertFile.o
  rm InsertFile.o
  echo InsertFile

  CC -O -c AppendLine.c -o AppendLine.o
  ar -r TabText.a AppendLine.o
  rm AppendLine.o
  echo AppendLine

  CC -O -c AppendText.c -o AppendText.o
  ar -r TabText.a AppendText.o
  rm AppendText.o
  echo AppendText

  CC -O -c DeleteLine.c -o DeleteLine.o
  ar -r TabText.a DeleteLine.o
  rm DeleteLine.o
  echo DeleteLine

  CC -O -c DeleteWord.c -o DeleteWord.o
  ar -r TabText.a DeleteWord.o
  rm DeleteWord.o
  echo DeleteWord

  CC -O -c DeleteText.c -o DeleteText.o
  ar -r TabText.a DeleteText.o
  rm DeleteText.o
  echo DeleteText

  CC -O -c ReplaceString.c -o ReplaceString.o
  ar -r TabText.a ReplaceString.o
  rm ReplaceString.o
  echo ReplaceString

  echo "*** Memory functions ***"

  CC -O -c Alloc.c -o Alloc.o
  ar -r TabText.a Alloc.o
  rm Alloc.o
  echo Alloc

  CC -O -c Free.c -o Free.o
  ar -r TabText.a Free.o
  rm Free.o
  echo Free

  CC -O -c Return.c -o Return.o
  ar -r TabText.a Return.o
  rm Return.o
  echo Return

  echo "*** String functions ***"
  
  CC -O -c sstrstr.c -o sstrstr.o
  ar -r TabText.a sstrstr.o
  rm sstrstr.o
  echo sstrstr

  CC -O -c sstrncmp.c -o sstrncmp.o
  ar -r TabText.a sstrncmp.o
  rm sstrncmp.o
  echo sstrncmp

  CC -O -c sstrcmp.c -o sstrcmp.o
  ar -r TabText.a sstrcmp.o
  rm sstrcmp.o
  echo sstrcmp
