#ifndef lOUTPUT
#define lOUTPUT 256  // Lnge des Ausgabefeldes,
#endif
#ifndef EXTRA
#define EXTRA  2048  // Lnge der Zuordnungdeinheit
#endif
#include <stdlib.h>
#include <stdio.h>
#include <string.h>

typedef struct TextStruct
        { size_t lText,          // Textlnge
                 lFree;          // Freipltze
            char *Text,          // Text-Anfangszeiger
                 *Word,          // aktueller Wort-Zeiger
                 *Line,          // aktueller Zeilen-Zeiger
                 *Output,        // Ausgabe fr Zeile/Wort
                 *Ignore;        // Feld mit Ignorier-Zeichen
        } Text;
        
extern char* (*Strstr)(const char*, const char*);
extern int (*Strncmp)(const char*, const char*, size_t);
extern int (*Strcmp)(const char*, const char*);

extern char* sstrstr(const char*, const char*);
extern int sstrncmp(const char*, const char*, size_t);
extern int sstrcmp(const char*, const char*);
extern char *IGNORE;

extern char* Alloc(long int);
extern void Free(void*);
extern void Return(int);

extern Text OpenText(char* =0);
extern Text CopyText(Text*);
extern void CloseText(Text*);
extern unsigned char PrintText(Text*, char* ="", char* ="w+");
extern unsigned char ResetText(Text*);
extern size_t GetLine(Text*, size_t =1);
extern Text GetLine(Text*, char*);
extern size_t NextLine(Text*);
extern size_t PreviousLine(Text*);
extern size_t GetWord(Text*, size_t=0);
extern size_t GetWord(Text*, char*);
extern size_t GetWordinLine(Text*, size_t=0);
extern size_t GetWordinLine(Text*, char*);
extern unsigned char AppendLine(Text*, char*);
extern unsigned char AppendText(Text*, char*);
extern unsigned char InsertLine(Text*, char*);
extern unsigned char InsertText(Text*, char*);
extern unsigned char InsertFile(Text*, char*);
extern unsigned char DeleteText(Text*, char* =0, char* =0);
extern unsigned char DeleteLine(Text*, size_t =1);
extern unsigned char DeleteLine(Text*, char*);
extern unsigned char DeleteWord(Text*, size_t =1);
extern unsigned char DeleteWord(Text*, char*);
extern size_t ReplaceString(Text*, char* ="  ", char* =" ");
